/**
 * Diese Klasse implementiert eine verkettete Liste, die Postkarten speichert.
 * Dazu werden als Elemente Objekte vom Typ {@link MeinPostkartenListenElement}
 * benutzt.
 * 
 * @author Annabelle Klarl
 * 
 */
public class MeinePostkartenListe {

    private MeinPostkartenListenElement first;

    /**
     * Konstruktor: erstellt eine leere Liste
     */
    public MeinePostkartenListe() {
        this.first = null;
    }

    /**
     * Fügt die gegebene Postkarte an erster Stelle in die Liste ein. Alle
     * bisherigen Listen-Elemente werden um eins nach hinten gerückt.
     * 
     * @param postkarte
     */
    public void addFirst(Postkarte postkarte) {
        this.first = new MeinPostkartenListenElement(postkarte,
                this.first);
    }

    /**
     * Bestimmt die Anzahl der Elemente in der Liste
     * 
     * @return die Anzahl der Elemente in der Liste
     */
    public int size() {
        int size = 0;
        MeinPostkartenListenElement element = this.first;
        while (element != null) {
            element = element.getNext();
            size++;
        }
        return size;
    }

    /**
     * Gibt das Element an Position i in der Liste zurück (ohne es aus der Liste
     * zu löschen!)
     * 
     * @param i
     * @return das Listen-Element an Position i
     */
    public Postkarte get(int i) {
        MeinPostkartenListenElement element = this.first;
        while (element != null && i > 0) {
            element = element.getNext();
            i--;
        }
        if (element == null) {
        	throw new IndexOutOfBoundsException();
        }
        return element.getPostkarte();
    }
}
