/**
 * Diese Klasse implementiert eine verkettete Liste, die Rechnungen speichert.
 * Dazu werden als Elemente Objekte vom Typ {@link MeinRechnungsListenElement}
 * benutzt.
 * 
 * @author Annabelle Klarl
 * 
 */
public class MeineRechnungsListe {

    private MeinRechnungsListenElement first;

    /**
     * Konstruktor: erstellt eine leere Liste
     */
    public MeineRechnungsListe() {
        this.first = null;
    }

    /**
     * Fügt die gegebene Rechnung an erster Stelle in die Liste ein. Alle
     * bisherigen Listen-Elemente werden um eins nach hinten gerückt.
     * 
     * @param rechnung
     */
    public void addFirst(Rechnung rechnung) {
        this.first = new MeinRechnungsListenElement(rechnung,
                this.first);
    }

    /**
     * Bestimmt die Anzahl der Elemente in der Liste
     * 
     * @return die Anzahl der Elemente in der Liste
     */
    public int size() {
        int size = 0;
        MeinRechnungsListenElement element = this.first;
        while (element != null) {
            element = element.getNext();
            size++;
        }
        return size;
    }

    /**
     * Gibt das Element an Position i in der Liste zurück (ohne es aus der Liste
     * zu löschen!)
     * 
     * @param i
     * @return das Listen-Element an Position i
     */
    public Rechnung get(int i) {
        MeinRechnungsListenElement element = this.first;
        while (element != null && i > 0) {
            element = element.getNext();
            i--;
        }
        if (element == null) {
        	throw new IndexOutOfBoundsException();
        }
        return element.getRechnung();
    }
}
